dnl -------------------------------------------------------- -*- autoconf -*-
dnl                                                                      
dnl Copyright (c) Microsoft Corporation                                
dnl                                                                      
dnl All rights reserved.                                               
dnl                                                                     
dnl Licensed under the Apache License, Version 2.0 (the "License");    
dnl you may not use this file except in compliance with the License.   
dnl You may obtain a copy of the License at                            
dnl http://www.apache.org/licenses/LICENSE-2.0                         
dnl                                                                    
dnl THIS CODE IS PROVIDED *AS IS* BASIS, WITHOUT WARRANTIES OR         
dnl CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING       
dnl WITHOUT LIMITATION ANY IMPLIED WARRANTIES OR CONDITIONS OF TITLE,  
dnl FITNESS FOR A PARTICULAR PURPOSE, MERCHANTABLITY OR                
dnl NON-INFRINGEMENT.                                                  
dnl                                                                     
dnl See the Apache Version 2.0 License for specific language           
dnl governing permissions and limitations under the License.           

dnl
dnl find_apxs.m4 : locate the Apache Extension tool (apxs)
dnl
dnl
dnl FIND_APXS()
dnl
dnl Sets the following variables on exit:
dnl
dnl   apxs_found : "yes", "no"
dnl
dnl If apxs_found is "yes", then the caller should use the
dnl value of APXS to fetch any necessary build/link information.
dnl


AC_DEFUN([FIND_APXS], [
  apxs_found="no"

  AC_MSG_CHECKING(for apxs)
  AC_ARG_WITH(apxs,
              [AS_HELP_STRING([[--with-apxs[=FILE]]],
                              [path to the apxs, defaults to "apxs".])],
              [
                if test "$withval" = "yes"; then
                  APXS=apxs
                else
                  APXS="$withval"
                fi
              ])
  
  if test -z "$APXS"; then
    for i in /usr/sbin /usr/local/apache/bin /usr/local/apache2/bin /usr/bin ; do
      if test -x "$i/apxs2"; then
        APXS="$i/apxs2"
        apxs_found="yes"
        break
      fi
      if test -x "$i/apxs"; then
        APXS="$i/apxs"
        apxs_found="yes"
        break
      fi
    done
  fi

  AC_MSG_RESULT($apxs_found)
])
