/***********************************************************************
*                                                                      *
*   Copyright (c) Microsoft Corporation                                *
*                                                                      *
*   All rights reserved.                                               *
*                                                                      *
*   Licensed under the Apache License, Version 2.0 (the "License");    *
*   you may not use this file except in compliance with the License.   *
*   You may obtain a copy of the License at                            *
*   http://www.apache.org/licenses/LICENSE-2.0                         *
*                                                                      *
*   THIS CODE IS PROVIDED *AS IS* BASIS, WITHOUT WARRANTIES OR         *
*   CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING       *
*   WITHOUT LIMITATION ANY IMPLIED WARRANTIES OR CONDITIONS OF TITLE,  *
*   FITNESS FOR A PARTICULAR PURPOSE, MERCHANTABLITY OR                *
*   NON-INFRINGEMENT.                                                  *
*                                                                      *
*   See the Apache Version 2.0 License for specific language           *
*   governing permissions and limitations under the License.           *
*                                                                      *
***********************************************************************/
#pragma once

#include "FilesCommon.h"
#include "SSPTypes.h"

// Magic number doubles as a file format version.
// These were generated randomly, although simply incrementing would be no worse.
#define DELTA_FILE_MAGIC_HEADER0 0x30d7b9aa
#define DELTA_FILE_MAGIC_HEADER1 0xc2cbd2da

static const unsigned c_rDeltaMagic[] = { DELTA_FILE_MAGIC_HEADER0, DELTA_FILE_MAGIC_HEADER1, 0 };

#define DELTA_FLAG_NONE 0
#define DELTA_FLAG_BOT 1

bool GenerateDeltaFileEntry(unsigned flags, Signature sig, VisitCount visitCount, const char* pbUrl, size_t cbUrl, __out_bcount_part(*pcbBuf,*pcbBuf) char* buf, size_t* pcbBuf);
bool ReadDeltaFileEntry(IFileReader* pFile, unsigned* pFlags, Signature* pSig, VisitCount* pVisitCount, __out_bcount_part(*pcbUrl,*pcbUrl) char* pbUrl, size_t* pcbUrl);

