/***********************************************************************
*                                                                      *
*   Copyright (c) Microsoft Corporation                                *
*                                                                      *
*   All rights reserved.                                               *
*                                                                      *
*   Licensed under the Apache License, Version 2.0 (the "License");    *
*   you may not use this file except in compliance with the License.   *
*   You may obtain a copy of the License at                            *
*   http://www.apache.org/licenses/LICENSE-2.0                         *
*                                                                      *
*   THIS CODE IS PROVIDED *AS IS* BASIS, WITHOUT WARRANTIES OR         *
*   CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING       *
*   WITHOUT LIMITATION ANY IMPLIED WARRANTIES OR CONDITIONS OF TITLE,  *
*   FITNESS FOR A PARTICULAR PURPOSE, MERCHANTABLITY OR                *
*   NON-INFRINGEMENT.                                                  *
*                                                                      *
*   See the Apache Version 2.0 License for specific language           *
*   governing permissions and limitations under the License.           *
*                                                                      *
***********************************************************************/
#pragma once

#include "PAL.h"

#ifdef __TARGET_APACHE__

#if !APR_HAVE_WINDOWS_H
// These are definitions for non-Windows platforms.
#ifndef BOOL
#define BOOL int
#endif

#ifndef TRUE
#define TRUE (1)
#endif

#ifndef FALSE
#define FALSE (0)
#endif

// HRESULT errors
#define NO_ERROR APR_SUCCESS
#define NOERROR APR_SUCCESS
#define ERROR_HANDLE_EOF APR_EOF
#define ERROR_OUTOFMEMORY APR_ENOSHMAVAIL
#define ERROR_ENCRYPTION_FAILED APR_EGENERAL
#define ERROR_DECRYPTION_FAILED APR_EGENERAL
#define ERROR_INVALID_DATA APR_EGENERAL
#define ERROR_INVALID_PARAMETER APR_EGENERAL


#ifdef _UNICODE
typedef wchar_t TCHAR;
#define TEXT(x) L ## x
#else
typedef char TCHAR;
#define TEXT(x) x
#endif

#define GetCurrentProcessId getpid

#define UNREFERENCED_PARAMETER(P) (P)

#ifndef max
#define max(a,b)            (((a) > (b)) ? (a) : (b))
#endif

#ifndef min
#define min(a,b)            (((a) < (b)) ? (a) : (b))
#endif

#define memcpy_s(a,b,c,d) memcpy((a),(c),(d))

// Time definitions
#define gmtime_s(x, y) (gmtime_r((y), (x)) != NULL ? 0 : 1)
#define localtime_s(x, y) (localtime_r((y), (x)) != NULL ? 0 : 1)

// Sleep function
#define Sleep(x) usleep((x) * 1000)

// Rotation definitions
#define _rotl(x, y) (((x) << (y)) | ((x) >> (32 - (y))))
#define _rotr(x, y) (((x) >> (y)) | ((x) << (32 - (y))))

typedef apr_byte_t BYTE;
typedef unsigned int UINT;
typedef unsigned long ULONG;
typedef long LONG;
typedef apr_uint64_t ULONGLONG;
typedef apr_uint64_t LONG64;

typedef apr_uint16_t WORD;
typedef apr_uint32_t DWORD;
typedef apr_uint32_t DWORD32;
typedef apr_uint64_t DWORD64;


typedef void *PVOID;
typedef void *LPVOID;
typedef PVOID HANDLE;

typedef struct _FILETIME {
   DWORD dwLowDateTime;   /* low 32 bits  */
   DWORD dwHighDateTime;  /* high 32 bits */
} FILETIME, *PFILETIME, *LPFILETIME;
#endif

#ifdef _DEBUG
#define DEBUG_ap_log_perror(...) ap_log_perror(__VA_ARGS__)
#define DEBUG_ap_log_rerror(...) ap_log_rerror(__VA_ARGS__)
#else
#define DEBUG_ap_log_perror(...)
#define DEBUG_ap_log_rerror(...)
#endif

#endif
