/***********************************************************************
*                                                                      *
*   Copyright (c) Microsoft Corporation                                *
*                                                                      *
*   All rights reserved.                                               *
*                                                                      *
*   Licensed under the Apache License, Version 2.0 (the "License");    *
*   you may not use this file except in compliance with the License.   *
*   You may obtain a copy of the License at                            *
*   http://www.apache.org/licenses/LICENSE-2.0                         *
*                                                                      *
*   THIS CODE IS PROVIDED *AS IS* BASIS, WITHOUT WARRANTIES OR         *
*   CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING       *
*   WITHOUT LIMITATION ANY IMPLIED WARRANTIES OR CONDITIONS OF TITLE,  *
*   FITNESS FOR A PARTICULAR PURPOSE, MERCHANTABLITY OR                *
*   NON-INFRINGEMENT.                                                  *
*                                                                      *
*   See the Apache Version 2.0 License for specific language           *
*   governing permissions and limitations under the License.           *
*                                                                      *
***********************************************************************/

// no #pragma once because this header is included multiple times, with different expansions for the _PARAM() macros each time

// name,default,min,max (max==0 means no max)
TCHAR_PARAM(RobotsTxtFilename,"robots.txt") // robots.txt file name within wwwroot
TCHAR_PARAM(wwwroot,"")
CHAR_PARAM(wwwhost,"")

BOOL_PARAM(WriteToRobots,g_fWriteToRobotsByDefault) // if fPublishSitemap==FALSE, fWriteToRobots is implicitly FALSE
BOOL_PARAM(PublishSitemap,g_fPublishSitemapByDefault)
BOOL_PARAM(PingSearchEngines,g_fPingSearchEngines)
BOOL_PARAM(gzip,g_fGZipSitemapsByDefault)
BOOL_PARAM(MultiServerWorker,TRUE) // use FALSE to disable the generation of DeltaSnapshot.dat, which is only needed for multi-server scenario
BOOL_PARAM(Decompress,TRUE)
BOOL_PARAM(HelpSSP, g_fHelpSSPByDefault)

FLOAT_PARAM(NumVisitsDecayFactor,0.8f)

UINT_PARAM(MaxSnapshotFileMB,4096,64,16384)
UINT_PARAM(MaxMemoryCacheMB,32,4,1024)
UINT_PARAM(SitemapGenerationPeriodHours,24,1,168)
UINT_PARAM(SignatureComputationPeriodSec,1800,300,43200)
UINT_PARAM(MaxSecondsPerFile,21600,0,0)
UINT_PARAM(VisitTimeoutSec,30 * 86400,0,0) // 86400 seconds == 1 day
UINT_PARAM(ChangeFreqResetPeriodSec,100 * 86400,0,0)
UINT_PARAM(MergeCacheMemoryMB,512,0,0)
UINT_PARAM(DeltaEntryPeriodSec,15 * 86400,0,0)
UINT_PARAM(CacheSavePeriodSec,3600,0,0)
UINT_PARAM(CountersSavePeriodSec,900,0,0)
UINT_PARAM(MinDocumentSizeBytes,65536,0,0)
UINT_PARAM(MaxDocumentSizeBytes,16777216,0,0)
UINT_PARAM(DiskUsageCheckPeriodSec,0,0,0)
UINT_PARAM(DiskMinFreeMB,100,0,0)
UINT_PARAM(DiskMaxFreeMB,100 * 1024,0,0)
#if defined(_X86_)
UINT_PARAM(MaxHeapMB,1024,0,0)
#else
UINT_PARAM(MaxHeapMB,4096,0,0)
#endif
UINT_PARAM(MaxUserAgent,1024,0,0)
UINT_PARAM(MaxWhitelistQueryParameters,1024,0,0)
UINT_PARAM(MaxAgeToMergeSec,1000000,0,0) // 11 days
UINT_PARAM(StopEventCheckPeriodEntries,1000000,0,0)
UINT_PARAM(NumVisitsPerDeltaPriority,25,0,0)
UINT_PARAM(NumVisitsPerFullPriority,100,0,0)


