/***********************************************************************
*                                                                      *
*   Copyright (c) Microsoft Corporation                                *
*                                                                      *
*   All rights reserved.                                               *
*                                                                      *
*   Licensed under the Apache License, Version 2.0 (the "License");    *
*   you may not use this file except in compliance with the License.   *
*   You may obtain a copy of the License at                            *
*   http://www.apache.org/licenses/LICENSE-2.0                         *
*                                                                      *
*   THIS CODE IS PROVIDED *AS IS* BASIS, WITHOUT WARRANTIES OR         *
*   CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING       *
*   WITHOUT LIMITATION ANY IMPLIED WARRANTIES OR CONDITIONS OF TITLE,  *
*   FITNESS FOR A PARTICULAR PURPOSE, MERCHANTABLITY OR                *
*   NON-INFRINGEMENT.                                                  *
*                                                                      *
*   See the Apache Version 2.0 License for specific language           *
*   governing permissions and limitations under the License.           *
*                                                                      *
***********************************************************************/
#pragma once

#include "CompressingWriter.h"
#include "counters.h"
#include "DiskSpaceTracker.h"

class FileWriter
{
    int m_ics;
    CompressingFileWriter m_writer;
    Size_t m_cb;
    time_t m_tOpenTime;
    unsigned m_maxSecondsPerFile;
    DiskSpaceTracker *m_pDiskSpaceTracker;

    Counters* m_pCounters;
    const TCHAR* m_pwszFolder;
    TCHAR m_wszTempFile[MAX_PATH];

    BOOL TimeExpired();
    void FlushHelper();
public:
    BOOL Initialize(
        IAllocator* pAlloc,
        ICritSecDispenser* pCSD,
        const TCHAR* wszFolder,
        unsigned maxSecondsPerFile,
        Counters* pCounters,
        DiskSpaceTracker *pDiskSpaceTracker);

    void Write(const char* pb, Size_t cb);
    void Flush();
    void Tick();
};
