/***********************************************************************
*                                                                      *
*   Copyright (c) Microsoft Corporation                                *
*                                                                      *
*   All rights reserved.                                               *
*                                                                      *
*   Licensed under the Apache License, Version 2.0 (the "License");    *
*   you may not use this file except in compliance with the License.   *
*   You may obtain a copy of the License at                            *
*   http://www.apache.org/licenses/LICENSE-2.0                         *
*                                                                      *
*   THIS CODE IS PROVIDED *AS IS* BASIS, WITHOUT WARRANTIES OR         *
*   CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING       *
*   WITHOUT LIMITATION ANY IMPLIED WARRANTIES OR CONDITIONS OF TITLE,  *
*   FITNESS FOR A PARTICULAR PURPOSE, MERCHANTABLITY OR                *
*   NON-INFRINGEMENT.                                                  *
*                                                                      *
*   See the Apache Version 2.0 License for specific language           *
*   governing permissions and limitations under the License.           *
*                                                                      *
***********************************************************************/
#pragma once
#include "PALDefs.h"
#include "WSFilter.h"

// Apache-style interface
void ProcessResponse(WSFilter *pFilter);

#ifdef __TARGET_IIS__
// ISAPI-style interface
void OnSendResponse(PHTTP_FILTER_CONTEXT pfc, HTTP_FILTER_SEND_RESPONSE* pResponse);
void OnRawData(PHTTP_FILTER_CONTEXT pfc, HTTP_FILTER_RAW_DATA* pData);
void OnEndRequest(PHTTP_FILTER_CONTEXT pfc);
#endif

struct ConfigPluginGlobals
{
    Size_t cbSharedAllocatorSize;
    Size_t cbPrivateAllocatorSize;
    unsigned nMaxGlobalLocks;
#ifdef __TARGET_IIS__
    unsigned uSharedMemAddrMB;
#endif    
    void SetDefault();
};

// Wrapper functions for the PluginGlobals initializers.
// This will call both parent and child functions together and should
// only be used in single process servers (ie, IIS).
BOOL InitializePlugin(const ConfigPluginGlobals &config, void *pPlatformMemPool);
void FreePlugin(void *pPlatformMemPool);

// one-time global init - DLL load or similar
BOOL InitPluginGlobals(const ConfigPluginGlobals &config, void *pPlatformMemPool );
BOOL InitPluginGlobalsChild(void *pPlatformMemPool);
void FreePluginGlobals(void *pPlatformMemPool);
void FreePluginGlobalsChild(void *pPlatformMemPool);


