/***********************************************************************
*                                                                      *
*   Copyright (c) Microsoft Corporation                                *
*                                                                      *
*   All rights reserved.                                               *
*                                                                      *
*   Licensed under the Apache License, Version 2.0 (the "License");    *
*   you may not use this file except in compliance with the License.   *
*   You may obtain a copy of the License at                            *
*   http://www.apache.org/licenses/LICENSE-2.0                         *
*                                                                      *
*   THIS CODE IS PROVIDED *AS IS* BASIS, WITHOUT WARRANTIES OR         *
*   CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING       *
*   WITHOUT LIMITATION ANY IMPLIED WARRANTIES OR CONDITIONS OF TITLE,  *
*   FITNESS FOR A PARTICULAR PURPOSE, MERCHANTABLITY OR                *
*   NON-INFRINGEMENT.                                                  *
*                                                                      *
*   See the Apache Version 2.0 License for specific language           *
*   governing permissions and limitations under the License.           *
*                                                                      *
***********************************************************************/

#pragma once
#include "PluginSite.h"
#include "SimpleHashTable.h"
#include "HostMapping.h"
#include "PlatformSpecificPluginGlobals.h"
#include "WSFilter.h"

class PluginShared // across processes under Apache
{
    SimpleHashTable<PluginSite*> m_sites;
    HostMapping m_hostMapping;
    BOOL m_fUseHostMapping;
    BOOL m_bInit;

    BOOL GetMappingFile(__out_ecount(cchMappingFile)TCHAR* wszMappingFile, Size_t cchMappingFile);

public:
    BOOL Initialize(IAllocator* pAlloc);
    BOOL IsInit() const { return m_bInit; };
    void Free(BOOL bFlushOnly = FALSE);
    PluginSite* GetSite(IUnrollableAllocator*, ICritSecDispenser*, WSFilter *pFilter, ICriticalSection* pcs);
};
